Attribute VB_Name = "mFSO"
'''''''''''''''''''''''''''''
'
' mFSO
' Ȩ 2009-2018 ZX Inc.
' 汾 2.0.21
' : Windows 95+, Win9xUNICOWS
'
' : ʹAPIȡļ(Unicode)
'
'''''''''''''''''''''''''''''
Option Explicit

'Private Type SECURITY_ATTRIBUTES
'    nLength As Long
'    lpSecurityDescriptor As Long
'    bInheritHandle As Long
'End Type
'Private Type OVERLAPPED
'    Internal As Long
'    InternalHigh As Long
'    Offset As Long
'    OffsetHigh As Long
'    hEvent As Long
'End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type
Private Type WIN32_FILE_ATTRIBUTE_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
End Type

Private Const CP_ACP = 0
Private Const CP_UTF8 = 65001
Private Const CP_UTF16 = 1200
Private Const CP_UTF16BE = 1201
Private Const CP_UTF32 = 12000
Private Const CP_UTF32BE = 12001
Private Const ERROR_ALREADY_EXISTS = 183
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const FILE_ATTRIBUTE_READONLY = &H1
Private Const FILE_ATTRIBUTE_DIRECTORY = &H10
Private Const FILE_BEGIN = 0
Private Const FILE_CURRENT = 1
Private Const FILE_END = 2
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const GetFileExInfoStandard = 0
Private Const INVALID_FILE_ATTRIBUTES = -1
Private Const INVALID_HANDLE_VALUE = -1
Private Const CREATE_NEW = 1
Private Const CREATE_ALWAYS = 2
Private Const OPEN_EXISTING = 3
Private Const OPEN_ALWAYS = 4

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (ByRef lpFileTime As FILETIME, ByRef lpSystemTime As SYSTEMTIME) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, ByRef lpFileSizeHigh As Long) As Long
'Private Declare Function GetLastError Lib "kernel32" () As Long
'Private Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)
'Private Declare Sub GetSystemTimeAsFileTime Lib "kernel32" (lpFileTime As FILETIME)
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, ByRef lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
'Private Declare Function SetFileTime Lib "kernel32" (ByVal hFile As Long, ByVal lpCreationTime As Long, ByVal lpLastAccessTime As Long, ByVal lpLastWriteTime As Long) As Long
Private Declare Function SystemTimeToTzSpecificLocalTime Lib "kernel32" (ByVal lpTimeZone As Long, ByRef lpUniversalTime As SYSTEMTIME, ByRef lpLocalTime As SYSTEMTIME) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long

Private Declare Function SystemTimeToVariantTime Lib "oleaut32" (ByRef lpSystemTime As SYSTEMTIME, ByRef pvtime As Date) As Long

#If USE_UNICOWS Then

Private Declare Function CopyFileW Lib "unicows.dll" (ByVal lpExistingFileName As Long, ByVal lpNewFileName As Long, ByVal bFailIfExists As Long) As Long
Private Declare Function CreateDirectoryW Lib "unicows.dll" (ByVal lpPathName As Long, ByVal lpSecurityAttributes As Long) As Long
Private Declare Function CreateFileW Lib "unicows.dll" (ByVal lpFileName As Long, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function DeleteFileW Lib "unicows.dll" (ByVal lpFileName As Long) As Long
Private Declare Function GetCurrentDirectoryW Lib "unicows.dll" (ByVal nBufferLength As Long, ByVal lpBuffer As Long) As Long
Private Declare Function GetFileAttributesW Lib "unicows.dll" (ByVal lpFileName As Long) As Long
Private Declare Function GetFileAttributesExW Lib "unicows.dll" (ByVal lpFileName As Long, ByVal fInfoLevelId As Long, ByRef lpFileInformation As Any) As Long
Private Declare Function GetSystemDirectoryW Lib "unicows.dll" (ByVal lpBuffer As Long, ByVal nBufferLength As Long) As Long
Private Declare Function GetWindowsDirectoryW Lib "unicows.dll" (ByVal lpBuffer As Long, ByVal nBufferLength As Long) As Long
Private Declare Function RemoveDirectoryW Lib "unicows.dll" (ByVal lpPathName As Long) As Long
Private Declare Function SetCurrentDirectoryW Lib "unicows.dll" (ByVal lpPathName As Long) As Long
Private Declare Function SetFileAttributesW Lib "unicows.dll" (ByVal lpFileName As Long, ByVal dwFileAttributes As Long) As Long

Private Declare Function MultiByteToWideChar Lib "unicows.dll" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function WideCharToMultiByte Lib "unicows.dll" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpDefaultChar As Long, ByVal lpUsedDefaultChar As Long) As Long

#Else

Private Declare Function CopyFileW Lib "kernel32" (ByVal lpExistingFileName As Long, ByVal lpNewFileName As Long, ByVal bFailIfExists As Long) As Long
Private Declare Function CreateDirectoryW Lib "kernel32" (ByVal lpPathName As Long, ByVal lpSecurityAttributes As Long) As Long
Private Declare Function CreateFileW Lib "kernel32" (ByVal lpFileName As Long, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function DeleteFileW Lib "kernel32" (ByVal lpFileName As Long) As Long
Private Declare Function GetCurrentDirectoryW Lib "kernel32" (ByVal nBufferLength As Long, ByVal lpBuffer As Long) As Long
Private Declare Function GetFileAttributesW Lib "kernel32" (ByVal lpFileName As Long) As Long
Private Declare Function GetFileAttributesExW Lib "kernel32" (ByVal lpFileName As Long, ByVal fInfoLevelId As Long, ByRef lpFileInformation As Any) As Long
Private Declare Function GetSystemDirectoryW Lib "kernel32" (ByVal lpBuffer As Long, ByVal nBufferLength As Long) As Long
Private Declare Function GetWindowsDirectoryW Lib "kernel32" (ByVal lpBuffer As Long, ByVal nBufferLength As Long) As Long
Private Declare Function RemoveDirectoryW Lib "kernel32" (ByVal lpPathName As Long) As Long
Private Declare Function SetCurrentDirectoryW Lib "kernel32" (ByVal lpPathName As Long) As Long
Private Declare Function SetFileAttributesW Lib "kernel32" (ByVal lpFileName As Long, ByVal dwFileAttributes As Long) As Long

Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpDefaultChar As Long, ByVal lpUsedDefaultChar As Long) As Long

Private Declare Sub PathStripPathW Lib "shlwapi" (ByVal Path As Long)

#End If

'Private Declare Function PathFileExistsW Lib "shlwapi" (ByVal pszPath As Long) As Boolean
'Private Declare Function PathIsDirectoryW Lib "shlwapi" (ByVal pszPath As Long) As Long

Public Function FileExists(PathName As String) As Boolean
    'FileExists = PathFileExistsW(StrPtr(Path))
    Dim ret As Long
    ret = GetFileAttributesW(StrPtr(PathName))
    FileExists = (ret <> INVALID_FILE_ATTRIBUTES) And (ret And Not FILE_ATTRIBUTE_DIRECTORY)
End Function

Public Function FolderExists(PathName As String) As Boolean
    'FolderExists = PathFileExistsW(StrPtr(Path)) And (PathIsDirectoryW(StrPtr(Path)) <> 0)
    Dim ret As Long
    ret = GetFileAttributesW(StrPtr(PathName))
    FolderExists = (ret <> INVALID_FILE_ATTRIBUTES) And (ret And FILE_ATTRIBUTE_DIRECTORY)
End Function

Public Sub FileCopy(Source As String, Destination As String, Optional Overwrite As Boolean = True)
    Dim ret As Long
    ret = CopyFileW(StrPtr(Source), StrPtr(Destination), Not Overwrite)
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

Public Function FileDateTime(PathName As String) As Date
    Dim ret As Long, Data As WIN32_FILE_ATTRIBUTE_DATA, st As SYSTEMTIME, st2 As SYSTEMTIME, d As Date
    ret = GetFileAttributesExW(StrPtr(PathName), GetFileExInfoStandard, Data)
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    Else
        ret = FileTimeToSystemTime(Data.ftLastWriteTime, st)
        ret = SystemTimeToTzSpecificLocalTime(0, st, st2)
        ret = SystemTimeToVariantTime(st2, d)
        FileDateTime = d
    End If
End Function

Public Function FileLen(PathName As String) As Long
    Dim ret As Long, Data As WIN32_FILE_ATTRIBUTE_DATA
    ret = GetFileAttributesExW(StrPtr(PathName), GetFileExInfoStandard, Data)
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
        FileLen = -1
    Else
        FileLen = Data.nFileSizeLow
    End If
End Function

Public Function GetAttr(PathName As String) As VbFileAttribute
    Dim ret As Long
    ret = GetFileAttributesW(StrPtr(PathName))
    If ret = INVALID_FILE_ATTRIBUTES Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
    GetAttr = ret
End Function

Public Sub SetAttr(PathName As String, Attributes As VbFileAttribute)
    Dim ret As Long
    ret = SetFileAttributesW(StrPtr(PathName), Attributes)
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

Public Sub Kill(PathName As String)
    Dim ret As Long
    ret = DeleteFileW(StrPtr(PathName))
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

Public Sub ChDir(Path As String)
    Dim ret As Long
    ret = SetCurrentDirectoryW(StrPtr(Path))
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

Public Function CurDir() As String
    Dim ret As Long, s$
    ret = GetCurrentDirectoryW(0, 0)
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
    s = Space$(ret)
    ret = GetCurrentDirectoryW(ret, StrPtr(s))
    CurDir = Left$(s, ret)
End Function

Public Sub MkDir(Path As String)
    Dim ret As Long, t$, L&, p&
    p = InStr(Path, ":")
    If p > 0 Then p = p + 2 Else p = 2
    L = Len(Path)
    While p < L
        t$ = Mid$(Path, p, 1)
        If t$ = "/" Or t$ = "\" Then
            t$ = Left$(Path, p)
            ret = CreateDirectoryW(StrPtr(t$), 0)
            If ret = 0 Then
                If Err.LastDllError <> ERROR_ALREADY_EXISTS Then
                    Err.Raise LastErrorToVBError(Err.LastDllError)
                End If
            End If
        End If
        p = p + 1
    Wend
    ret = CreateDirectoryW(StrPtr(Path), 0)
    If ret = 0 Then
        If Err.LastDllError <> ERROR_ALREADY_EXISTS Then
            Err.Raise LastErrorToVBError(Err.LastDllError)
        End If
    End If
End Sub

Public Sub RmDir(Path As String)
    Dim ret As Long
    ret = RemoveDirectoryW(StrPtr(Path))
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

Public Function PathAppend(Prefix As String, Path As String) As String
    Dim c As Long
    If Path = "" Then
        PathAppend = Prefix
    ElseIf InStr(Path, ":") Then            ' :
        PathAppend = Path
    Else
        c = AscW(Path)
        If c = &H2F Or c = &H5C Then        ' / \
            PathAppend = Path
        Else
            c = AscW(Right$(Prefix, 1))
            If c = &H2F Or c = &H5C Then    ' / \
                PathAppend = Prefix & Path
            Else
                PathAppend = Prefix & "/" & Path
            End If
        End If
    End If
End Function

Public Function PathStripPath(Path As String) As String
    Dim c As Long
    Call PathStripPathW(StrPtr(Path))
    PathStripPath = Trunc(Path)
End Function

Public Function TextToUnicode(ByRef s() As Byte, Optional ByVal DefaultAnsiCodePage As Long = CP_ACP) As String
    Dim Size As Long, L As Long, CP As Long, rt As String
    
    On Error GoTo EmptyArray    ' ᱨ
    Size = UBound(s) + 1
    On Error GoTo 0
    
    CP = DefaultAnsiCodePage
    If Size >= 4 Then
        If s(0) = &HFF And s(1) = &HFE And s(2) = 0 And s(3) = 0 Then
            CP = CP_UTF32
            GoTo Convert32
        ElseIf s(0) = 0 And s(1) = 0 And s(2) = &HFE And s(3) = &HFF Then
            CP = CP_UTF32BE
            GoTo Convert32BE
        End If
    End If
    If Size >= 3 Then
        If s(0) = &HEF And s(1) = &HBB And s(2) = &HBF Then
            CP = CP_UTF8
            GoTo Convert8
        End If
    End If
    If Size >= 2 Then
        If s(0) = &HFF And s(1) = &HFE Then
            CP = CP_UTF16
            GoTo Convert16
        ElseIf s(0) = &HFE And s(1) = &HFF Then
            CP = CP_UTF16BE
            GoTo Convert16BE
        ElseIf s(1) = 0 Then    ' UTF16LEľBOMĳЩ
            CP = CP_UTF16
            GoTo Convert16
        End If
    End If
Convert8:
    L = MultiByteToWideChar(CP, 0, VarPtr(s(0)), Size, 0, 0)
    rt = Space$(L)
    MultiByteToWideChar CP, 0, VarPtr(s(0)), Size, StrPtr(rt), L
    GoTo Finally
Convert16:
Convert16BE:    'ݲʵ
Convert32:      'ݲʵ
Convert32BE:    'ݲʵ
EmptyArray:
    rt = s
    GoTo Finally
Finally:
    If Left$(rt, 1) = ChrW$(&HFEFF) Then rt = Mid$(rt, 2)
    TextToUnicode = rt
End Function

Public Function ArrayToString(a() As Byte) As String
ArrayToString = a
End Function

Public Function StringToArray(s As String) As Byte()
StringToArray = s
End Function

Public Function StringToAnsiArray(s As String, Optional ByVal LCID As Long) As Byte()
    StringToAnsiArray = StrConv(s, vbFromUnicode, LCID)
End Function

Public Function StringToAnsiArrayByCP(s As String, Optional ByVal CodePage As Long = CP_ACP) As Byte()
    Dim TmpArr() As Byte, StrLen As Long, ArrLen As Long
    StrLen = Len(s)     ' ﲻüϽβnull
    ArrLen = WideCharToMultiByte(CodePage, 0, StrPtr(s), StrLen, 0, 0, 0, 0)
    ReDim TmpArr(0 To ArrLen - 1) As Byte
    WideCharToMultiByte CodePage, 0, StrPtr(s), StrLen, VarPtr(TmpArr(0)), ArrLen, 0, 0
    StringToAnsiArrayByCP = TmpArr
End Function

Public Sub CreateNewFile(FileName As String, Optional ByVal Overwrite As Boolean = True, Optional ByVal Unicode As Boolean = False)
    Dim fHandle As Long, fSuccess As Long, lBytesWritten As Long
    
    If Overwrite Then
        fHandle = CreateFileW(StrPtr(FileName), GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0)
    Else
        fHandle = CreateFileW(StrPtr(FileName), GENERIC_WRITE, 0, 0, CREATE_NEW, 0, 0)
    End If
    If fHandle <> INVALID_HANDLE_VALUE Then
        If Unicode Then
            fSuccess = WriteFile(fHandle, StrPtr(ChrW$(&HFEFF)), 2, lBytesWritten, 0)
        End If
        fSuccess = CloseHandle(fHandle)
    Else
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

' ȡļɹ0ʧܷط0עȡļʹ2GiBļʱʧܡ
Public Function ReadAllFromFile(FileName As String, DestArray() As Byte) As Long
    Dim fHandle&, fSuccess&, nSize&, lBytesRead&, HighOff&
    
    ReadAllFromFile = 0
    fHandle = CreateFileW(StrPtr(FileName), GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0)
    If fHandle <> INVALID_HANDLE_VALUE Then
        On Error GoTo Fail
        nSize = GetFileSize(fHandle, HighOff)
        If HighOff <> 0 Or nSize < 0 Then GoTo Fail ''' >2GiB
        ReDim DestArray(nSize - 1) As Byte
        fSuccess = ReadFile(fHandle, VarPtr(DestArray(0)), nSize, lBytesRead, 0)
        If lBytesRead <> nSize Then ReadAllFromFile = Err.LastDllError
        fSuccess = CloseHandle(fHandle)
    Else
Fail:
        fSuccess = CloseHandle(fHandle)
        ReadAllFromFile = Err.LastDllError
    End If
End Function

' дļɹ0ʧܷط0
Public Function WriteAllToFile(FileName As String, SrcArray() As Byte) As Long
    Dim fHandle As Long, fSuccess As Long, nSize As Long, lBytesWritten As Long
    
    WriteAllToFile = 0
    On Error Resume Next
    fHandle = CreateFileW(StrPtr(FileName), GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
    If fHandle <> INVALID_HANDLE_VALUE Then
        nSize = UBound(SrcArray) + 1
        fSuccess = WriteFile(fHandle, VarPtr(SrcArray(0)), nSize, lBytesWritten, 0)
        If lBytesWritten <> nSize Then WriteAllToFile = Err.LastDllError
        fSuccess = CloseHandle(fHandle)
    Else
        WriteAllToFile = Err.LastDllError
    End If
End Function

Public Function AppendToFile(FileName As String, SrcArray() As Byte) As Long
    Dim fHandle As Long, fSuccess As Long, nSize As Long, lBytesWritten As Long

    AppendToFile = 0
    fHandle = CreateFileW(StrPtr(FileName), GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
    If fHandle <> INVALID_HANDLE_VALUE Then
        fSuccess = SetFilePointer(fHandle, 0, 0, FILE_END)
        nSize = UBound(SrcArray) + 1
        fSuccess = WriteFile(fHandle, VarPtr(SrcArray(0)), nSize, lBytesWritten, 0)
        If lBytesWritten <> nSize Then AppendToFile = 1
        fSuccess = CloseHandle(fHandle)
    Else
        AppendToFile = 1
    End If
End Function

Public Function LastErrorToVBError(ByVal LastErrorCode As Long) As Long
    Dim r As Long
    Select Case LastErrorCode
    Case 87
        r = 5
    Case 14
        r = 7
    Case 123
        r = 52
    Case 2
        r = 53
    Case 29, 30
        r = 57
    Case 80, 183
        r = 58
    Case 39, 112
        r = 61
    Case 38
        r = 62
    Case 4
        r = 67
    Case 5, 32, 33
        r = 70
    Case 3
        r = 76
    Case Else
        r = LastErrorCode
    End Select
    LastErrorToVBError = r
End Function

Private Function Trunc(s As String) As String
Dim a As Long
a = InStr(s, vbNullChar)
If a > 0 Then
    Trunc = Left$(s, a - 1)
Else
    Trunc = s
End If
End Function

